;SVCEQU/ASM - LSDOS 6.x
*LIST	OFF
;
;	- System Entrys/Equates - 6.3
;
;	Set up to be compatible with both TRSDOS/LS-DOS
;	and DOSPLUS naming conventions.
;
;	ASCII Control equivalences
;
NUL	EQU	0			; Filler
SOH	EQU	1			; Start of heading
STX	EQU	2			; Start of text
ETX	EQU	3			; End of text
EOT	EQU	4			; End of transmission
ENQ	EQU	5			; Enquiry
ACK	EQU	6			; Acknowledge
BEL	EQU	7			; Bell
BS	EQU	8			; Backspace
HT	EQU	9			; Horizontal tabulation
LF	EQU	10			; Line feed
VT	EQU	11			; Vertical tabulation
FF	EQU	12			; Form feed
CR	EQU	13			; Carriage return
SO	EQU	14			; Shift out
SI	EQU	15			; Shift in
DLE	EQU	16			; Data link escape
DC1	EQU	17			; Device control 1
DC2	EQU	18			; Device control 2
DC3	EQU	19			; Device control 3
DC4	EQU	20			; Device control 4
NAK	EQU	21			; Negative acknowledge
SYN	EQU	22			; Synchronous idle
ETB	EQU	23			; End of transmission block
CAN	EQU	24			; Cancel
EM	EQU	25			; End of medium
SUB	EQU	26			; Substitute
ESC	EQU	27			; Escape
FS	EQU	28			; File separator
GS	EQU	29			; Group separator
RS	EQU	30			; Record separator
US	EQU	31			; Unit separator

;	Keyboard/Display Chars

CURON	EQU	14			; Cursor display on
CUROF	EQU	15			; Cursor display off
BREAK	EQU	80H			; Break key
KEY_F1	EQU	81H			; Function key #1
KEY_F2	EQU	82H			; Function key #2
KEY_F3	EQU	83H			; Function key #3
;
;	Supervisor Call (SVC) Routines
;
@IPL	EQU	0			; 00 Initial program load
@KEY	EQU	1			; 01 Input from keyboard with wait
@DSP	EQU	2			; 02 Output to display
@GET	EQU	3			; 03 Input a byte from a device
@PUT	EQU	4			; 04 Output a byte to a device
@CTL	EQU	5			; 05 Output a control byte
@PRT	EQU	6			; 06 Output to printer
@WHERE	EQU	7			; 07 Resolve relocation address
@KBD	EQU	8			; 08 Accept keyboard input
@KEYIN	EQU	9			; 09 Line input routine
@DSPLY	EQU	10			; 0A Display line handler
@LOGER	EQU	11			; 0B Issue a log message
@LOGOT	EQU	12			; 0C Display and log a message
@MSG	EQU	13			; 0D Message line handler
@PRINT	EQU	14			; 0E Printer line handler
@VDCTL	EQU	15			; 0F Display control routine
@PAUSE	EQU	16			; 10 Suspend program execution
@PARAM	EQU	17			; 11 Scan optional parameters
@DATE	EQU	18			; 12 Get the date in display code
@TIME	EQU	19			; 13 Get the time in display code
@CHNIO	EQU	20			; 14 Chain character i/o
@ABORT	EQU	21			; 15 Abnormal program exit
@EXIT	EQU	22			; 16 Normal program exit
; 23 is reserved
@CMNDI	EQU	24			; 18 Execute command/@exit
@CMNDR	EQU	25			; 19 Execute command/return
@ERROR	EQU	26			; 1A Post an error message
@DEBUG	EQU	27			; 1B Enter debugging package
@CKTSK	EQU	28			; 1C Check interrupt task
@ADTSK	EQU	29			; 1D Add interrupt task
@RMTSK	EQU	30			; 1E Remove interrupt task
@RPTSK	EQU	31			; 1F Replace interrupt task
@KLTSK	EQU	32			; 20 Kill interrupt task
@CKDRV	EQU	33			; 21 Check drive/loc dir
@DODIR	EQU	34			; 22 Display file directory
@RAMDIR EQU	35			; 23 Ram/directory routine
;
; 36 through 39 reserved		; 24, 25, 26, 27
;
@DCSTAT EQU	40			; 28 No operation (check)
@SLCT	EQU	41			; 29 Select drive routine
@DCINIT EQU	42			; 2A Drive initialization
@DCRES	EQU	43			; 2B Clear controller
@RSTOR	EQU	44			; 2C Issue fdc restore cmd
@STEPI	EQU	45			; 2D Isue fdc step-in cmd
@SEEK	EQU	46			; 2E Seek a cylinder
@RSLCT	EQU	47			; 2F Test drive busy
@RDHDR	EQU	48			; 30 Read sector header info
@RDSEC	EQU	49			; 31 Read sector comand
@VRSEC	EQU	50			; 32 Verify if sector readable
@RDTRK	EQU	51			; 33 Issue fdc cyl read cmd
@HDFMT	EQU	52			; 34 Format the device
@WRSEC	EQU	53			; 35 Write a sector
@WRSSC	EQU	54			; 36 Write a system sector
@WRTRK	EQU	55			; 37 Issue fdc cyl write cmd
@RENAM	EQU	56			; 38 Rename device/file
@REMOVE	EQU	57			; 39 Kill a device/file
@REMOV	EQU	57			; 39 Kill a device/file
@KILL	EQU	57			; 39 Kill a device/file
@INIT	EQU	58			; 3A Open or initialize a device/file
@OPEN	EQU	59			; 3B Open an existing device/file
@CLOSE	EQU	60			; 3C Close a device/file
@BKSP	EQU	61			; 3D Backspace logical record
@CKEOF	EQU	62			; 3E Check for end-of-file
@LOC	EQU	63			; 3F Calc current logical record number
@LOF	EQU	64			; 40 Calc eof logical record number
@PEOF	EQU	65			; 41 Position to end-of-file
@POSN	EQU	66			; 42 Position to logical record
@READ	EQU	67			; 43 Read a record from a file
@REW	EQU	68			; 44 Rewind a file
@RREAD	EQU	69			; 45 Force a sector re-read
@RWRIT	EQU	70			; 46 Force a sector re-write
@SEEKCS EQU	71			; 47 Position to disk sector
@SKIP	EQU	72			; 48 Skip to next logical record
@VER	EQU	73			; 49 Write-verify a record to a file
@WEOF	EQU	74			; 4A Write an end-of-file mark
@WRITE	EQU	75			; 4B Write a record to a file
@LOAD	EQU	76			; 4C Load a program file
@RUN	EQU	77			; 4D Load and execute a program file
@FSPEC	EQU	78			; 4E Fetch a device/file specification
@FEXT	EQU	79			; 4F Set up a default file extension
@FNAME	EQU	80			; 50 Recover filename/ext
@GTDCT	EQU	81			; 51 Get drive table
@GTDCB	EQU	82			; 52 Get device block
@GTMOD	EQU	83			; 53 Get module
; 84 is reserved			; 54
@RDSSC	EQU	85			; 55 Read directory sector
@GATRD	EQU	86			; 56 Read GAT
@RDDIR	EQU	87			; 57 Read directory for file
@DIRRD	EQU	87			; 57 Read directory for file
@WRDIR	EQU	88			; 58 Write directory for file
@DIRWR	EQU	88			; 58 Write directory for file
@GATWR	EQU	89			; 59 Write GAT
@MULT8	EQU	90			; 5A Single precision multiply
@MUL8	EQU	90			; 5A Single precision multiply
@MULT16	EQU	91			; 5B Double precision multiply
@MUL16	EQU	91			; 5B Double precision multiply
; 92 is reserved			; 5C
@DIVD8	EQU	93			; 5D Single precision divide
@DIV8	EQU	93			; 5D Single precision divide
@DIVD16 EQU	94			; 5E Double precision divide
@DIV16	EQU	94			; 5E Double precision divide
@HDEC	EQU	95			; 5F
@DECBIN	EQU	96			; 60 Decimal to binary conversion
@DECHEX	EQU	96			; 60 Decimal to binary conversion
@BINDEC	EQU	97			; 61 Binary to decimal conversion
@HEXDEC	EQU	97			; 61 Binary to decimal conversion
@HEX8	EQU	98			; 62 Binary to hex conversion - 8 bit
@HEX16	EQU	99			; 63 Binary to hex conversion - 16 bit
@HIGH	EQU	100			; 64 Fetch/set high$ and low$
@HIGH$	EQU	100			; 64 Fetch/set high$ and low$
@FLAGS	EQU	101			; 65 Fetch system info
@BANK	EQU	102			; 66 Memory manager
@BREAK	EQU	103			; 67 Set backround break vector
@SOUND	EQU	104			; 68 Sound/beep routine

;	 TRSDOS/LS-DOS 6.2 EXTENDED SVC'S

@CLS	EQU	105			; 69 Clear video screen
@CKBRKC EQU	106			; 6A Check/clear break bit
@PRTSCR EQU	107			; 6B Print the screen
;
;@EXTMEM EQU	108			; 6C The Extended memory SVC goes here
; 108 through 127 reserved
;
;	DOSPLUS EXTENDED SVC'S

@DISKIO EQU	121			; 79 General disk i/o driver
@LOCDCT EQU	122			; 7A Locate drive ctl table
@LOCDCB EQU	123			; 7B Locate device ctl block
@EVAL	EQU	124			; 7C Command line evaluation
@WILD	EQU	125			; 7D Wild card parsing
@LOCDEV EQU	126			; 7E Locate device by name
@SORT	EQU	127			; 7F Sort memory block

*LIST	ON
